% Inexact AManPG methods over feasible set
function [proj_xopt_inexact, fs_inexact, Ds_inexact, sparsity_inexact, iter_inexact, nf_inexact, ng_inexact, nR_inexact,totalinneriterx_inexact, totalinneritery_inexact,totaltotalCGiter_inexact,nrestart_inexact,err_inexact,comtime_inexact] = IAManPG(A, n, p)
[V, D] = eigs(@(v)Mv(v, A), n, p-1);

Zo = [V, ones(n, 1) / sqrt(n)];

% x0 = Zo;
x0_inexact = Zo;
SallA = sum(sum(A));

% rho=0.5;    
% mu=0.1;
% [proj_xopt, fs, Ds, sparsity, iter, nf, ng, nR,totalinneriterx, totalinneritery,totaltotalCGiter,nrestart,err,comtime] = driver_AmanPG_SparseComputation(A, SallA, x0, n, p, 1e-3, 500, mu, 1e-10, -inf);
% fprintf('time of AManPG with fixed tol:%f\n', comtime);
% 
% transform proj_xopt to assignment matrix by making the abs maximum value of each row as 1, others as 0
% proj_xopt_assign=abs(proj_xopt);
% for row=1:n
%     [~, index]=max(proj_xopt_assign(row,:));        
%     if(proj_xopt_assign(row, index)~=0)
%         proj_xopt_assign(row, index)=1;
%     end
%     for column=1:p
%         if(column~=index)
%            proj_xopt_assign(row, column)=0;
%         end
%     end
% end
% 
% modu_assign = modu(proj_xopt_assign, A)
% 
% ind=zeros(1,n);
% for i=1:n
%     ind(i)=find(proj_xopt_assign(i,:));
% end
% ind;
% 
% format long      
% NMI=nmi(GT, ind)
% AMI=ami(GT+1, ind)
% Purity=purity(GT, ind)

% rho_inexact=0.5;
mu_inexact=0.3;
[proj_xopt_inexact,comtime_inexact] = driver_AManPG_Approx_SparseComputation(A, SallA, x0_inexact, n, p, 1e-3, 500, mu_inexact, -inf);
% [proj_xopt_inexact, fs_inexact, Ds_inexact, sparsity_inexact, iter_inexact, nf_inexact, ng_inexact, nR_inexact,totalinneriterx_inexact, totalinneritery_inexact,totaltotalCGiter_inexact,nrestart_inexact,err_inexact,comtime_inexact] = driver_IAManPG(A, x0_inexact, n, p, 1e-3, 500, mu_inexact, -inf);
fprintf('time of AManPG with dynamically update tol:%f\n', comtime_inexact);
end

function output = Mv(v, A)
    n = size(A, 1);
    SallA = sum(sum(A));
    tmp = A * ones(n, 1);
    output = A * v - tmp * ((tmp' * v) / SallA);
end
    
function output=projection(x, eta)
    q_star = x' * eta / norm(x' * eta);
    output = eta * q_star' + x - x * (q_star * q_star');
end

function output = LinesearchInput(x, eta, t0, s0)
    output = 1;
end

function output = IsStopped(x, gf, f, ngf, ngf0)
    output = ngf / ngf0 < 1e-5;
end

function [output, x] = f(x, A, D) %Keep A to get B, make sure sparse computation
[n, ~]=size(A); 
temp=A*sparse(ones(n, 1)); 
SallA = sum(sum(A));
Z=sparse(x.main'*temp);
x.BUD = A * x.main * D-temp*(Z'* D)/SallA;
output = - x.main(:)' * x.BUD(:);
end

function [output, x] = modu(x, A)
    [n,~]=size(A);
    temp=A*ones(n, 1); 
    SallA = sum(sum(A));
    Z=sparse(x'*temp);
    xAx = A * x-temp*Z'/SallA;
    output = sum(x(:) .* xAx(:))/SallA;
end

function [output, x] = gf(x, A, D) %Keep A to get B, make sure sparse computation
output.main = - 2 * x.BUD;
end

function [output, x] = Hess(x, eta, A, D) %Keep A to get B, make sure sparse computation
[n, ~]=size(A); 
temp=A*sparse(ones(n, 1)); 
SallA = sum(sum(A));
Z=sparse(eta.main'*temp);
output.main = - 2 * A * eta.main * D + 2*temp*(Z'* D)/SallA;
end

function [output, x] = PreCon(x, eta)
output = eta;
end