% diary(sprintf('testGraphLFR_AManPG_Inexact_%s_%d_%d_mu0_%d.txt',datestr(now,'yyyy_mm_dd_HH_MM_SS'),1024,16,7));
seed = floor(rand() * 1000000);       
fprintf('random seed:%d\n', seed);
% rng(seed); 
% rng(1);
n=1000;
p=[7 9 10 11 12 15 16 17 18 19 20 21 22 23];
numc=length(p);

%average results for comparison between I-AManPG and other existing
%algorithms
Avg_comparison_AManPG_Existing_Results=cell(numc, 1);

it=10;
for c = 1: numc
Avg_comparison_AManPG_Existing_Results{c}=zeros(6,9);
for j=1:9  
    sum_comtime_inexact=0;
    sum_modu_assign_inexact=0;
    sum_NMI_inexact=0;
    sum_AMI_inexact=0; 
    sum_Purity_inexact=0;
    sum_p_inexact=0;
    
    for k=1+it*(j-1):it*j
        [proj_xopt_inexact, fs_inexact, Ds_inexact, sparsity_inexact, iter_inexact, nf_inexact, ng_inexact, nR_inexact,totalinneriterx_inexact, totalinneritery_inexact,totaltotalCGiter_inexact,nrestart_inexact,err_inexact,comtime_inexact, modu_assign_inexact, NMI_inexact,AMI_inexact,Purity_inexact, p_inexact] = test_AManPG_Exact_Inexact(n, p(c), k)               
        sum_comtime_inexact=sum_comtime_inexact+comtime_inexact;
        sum_modu_assign_inexact=sum_modu_assign_inexact+modu_assign_inexact;
        sum_NMI_inexact=sum_NMI_inexact+NMI_inexact;
        sum_AMI_inexact=sum_AMI_inexact+AMI_inexact; 
        sum_Purity_inexact=sum_Purity_inexact+Purity_inexact;  
        sum_p_inexact=sum_p_inexact+p_inexact;       
    end
    
    avg_comtime_inexact=sum_comtime_inexact/it
    avg_modu_assign_inexact=sum_modu_assign_inexact/it
    avg_NMI_inexact=sum_NMI_inexact/it
    avg_AMI_inexact=sum_AMI_inexact/it
    avg_Purity_inexact=sum_Purity_inexact/it
    avg_p_inexact=sum_p_inexact/it
    
    Avg_comparison_AManPG_Existing_Results{c}(:,j)=[avg_NMI_inexact,avg_AMI_inexact,avg_modu_assign_inexact,avg_Purity_inexact,avg_comtime_inexact, avg_p_inexact]';
end
end
fout = fopen('Results_IAManPG_Existing_Comparison_LFR_n_1000_p_nested.txt','w');
for c=1:numc
for i = 1 : size(Avg_comparison_AManPG_Existing_Results{c}, 1)
    for j = 1 : size(Avg_comparison_AManPG_Existing_Results{c}, 2)
        if(mod(i,6)==0)
            fprintf(fout, '%d', round(Avg_comparison_AManPG_Existing_Results{c}(i, j)));
        else
            fprintf(fout, '%.4f', Avg_comparison_AManPG_Existing_Results{c}(i, j));
        end
        if(j < size(Avg_comparison_AManPG_Existing_Results{c}, 2))
            fprintf(fout, ' & ', Avg_comparison_AManPG_Existing_Results{c}(i, j));
        end
    end
    fprintf(fout,'\\\\\n');
end
end
fclose(fout);

function str = outputfloat(x)
    if(x <= 0)
        sn = '-';
        x = abs(x);
    else
        sn = '';
    end
    p = log(x)/log(10);
    p = - ceil(-p);
    x = round(x * 10^(-p) * 100);
    x = x / 100;
    strx = sprintf('%3.2f', x);
    if(p ~= 0)
        str = [sn strx '_{' num2str(p) '}'];
    else
        str = [sn strx];
    end
end

function [proj_xopt_inexact, fs_inexact, Ds_inexact, sparsity_inexact, iter_inexact, nf_inexact, ng_inexact, nR_inexact,totalinneriterx_inexact, totalinneritery_inexact,totaltotalCGiter_inexact,nrestart_inexact,err_inexact,comtime_inexact, modu_assign_inexact, NMI_inexact,AMI_inexact,Purity_inexact, p_inexact] = test_AManPG_Exact_Inexact(n, p, dataset)               

seed = floor(rand() * 1000000);       
fprintf('random seed:%d\n', seed);
% rng(seed); 
% rng(1);

% Set of test graphs=========
switch dataset
    case 1
        AA = load('network_1000_20_mu0_0_1.dat');
        u = load('community_1000_20_mu0_0_1.dat');
    case 2
        AA = load('network_1000_20_mu0_0_2.dat');
        u = load('community_1000_20_mu0_0_2.dat');
    case 3
        AA = load('network_1000_20_mu0_0_3.dat');
        u = load('community_1000_20_mu0_0_3.dat');
     case 4
        AA = load('network_1000_20_mu0_0_4.dat');
        u = load('community_1000_20_mu0_0_4.dat');
     case 5
        AA = load('network_1000_20_mu0_0_5.dat');
        u = load('community_1000_20_mu0_0_5.dat');
     case 6
        AA = load('network_1000_20_mu0_0_6.dat');
        u = load('community_1000_20_mu0_0_6.dat');
     case 7
        AA = load('network_1000_20_mu0_0_7.dat');
        u = load('community_1000_20_mu0_0_7.dat');
     case 8
        AA = load('network_1000_20_mu0_0_8.dat');
        u = load('community_1000_20_mu0_0_8.dat');
     case 9
        AA = load('network_1000_20_mu0_0_9.dat');
        u = load('community_1000_20_mu0_0_9.dat');
     case 10
        AA = load('network_1000_20_mu0_0_10.dat');
        u = load('community_1000_20_mu0_0_10.dat');
     case 11
        AA = load('network_1000_20_mu0_1_1.dat');
        u = load('community_1000_20_mu0_1_1.dat');
    case 12
        AA = load('network_1000_20_mu0_1_2.dat');
        u = load('community_1000_20_mu0_1_2.dat');
    case 13
        AA = load('network_1000_20_mu0_1_3.dat');
        u = load('community_1000_20_mu0_1_3.dat');
     case 14
        AA = load('network_1000_20_mu0_1_4.dat');
        u = load('community_1000_20_mu0_1_4.dat');
     case 15
        AA = load('network_1000_20_mu0_1_5.dat');
        u = load('community_1000_20_mu0_1_5.dat');
     case 16
        AA = load('network_1000_20_mu0_1_6.dat');
        u = load('community_1000_20_mu0_1_6.dat');
     case 17
        AA = load('network_1000_20_mu0_1_7.dat');
        u = load('community_1000_20_mu0_1_7.dat');
     case 18
        AA = load('network_1000_20_mu0_1_8.dat');
        u = load('community_1000_20_mu0_1_8.dat');
     case 19
        AA = load('network_1000_20_mu0_1_9.dat');
        u = load('community_1000_20_mu0_1_9.dat');
     case 20
        AA = load('network_1000_20_mu0_1_10.dat');
        u = load('community_1000_20_mu0_1_10.dat');
    case 21
        AA = load('network_1000_20_mu0_2_1.dat');
        u = load('community_1000_20_mu0_2_1.dat');
    case 22
        AA = load('network_1000_20_mu0_2_2.dat');
        u = load('community_1000_20_mu0_2_2.dat');
    case 23
        AA = load('network_1000_20_mu0_2_3.dat');
        u = load('community_1000_20_mu0_2_3.dat');
     case 24
        AA = load('network_1000_20_mu0_2_4.dat');
        u = load('community_1000_20_mu0_2_4.dat');
     case 25
        AA = load('network_1000_20_mu0_2_5.dat');
        u = load('community_1000_20_mu0_2_5.dat');
     case 26
        AA = load('network_1000_20_mu0_2_6.dat');
        u = load('community_1000_20_mu0_2_6.dat');
     case 27
        AA = load('network_1000_20_mu0_2_7.dat');
        u = load('community_1000_20_mu0_2_7.dat');
     case 28
        AA = load('network_1000_20_mu0_2_8.dat');
        u = load('community_1000_20_mu0_2_8.dat');
     case 29
        AA = load('network_1000_20_mu0_2_9.dat');
        u = load('community_1000_20_mu0_2_9.dat');
     case 30
        AA = load('network_1000_20_mu0_2_10.dat');
        u = load('community_1000_20_mu0_2_10.dat');
    case 31
        AA = load('network_1000_20_mu0_3_1.dat');
        u = load('community_1000_20_mu0_3_1.dat');
    case 32
        AA = load('network_1000_20_mu0_3_2.dat');
        u = load('community_1000_20_mu0_3_2.dat');
    case 33
        AA = load('network_1000_20_mu0_3_3.dat');
        u = load('community_1000_20_mu0_3_3.dat');
     case 34
        AA = load('network_1000_20_mu0_3_4.dat');
        u = load('community_1000_20_mu0_3_4.dat');
     case 35
        AA = load('network_1000_20_mu0_3_5.dat');
        u = load('community_1000_20_mu0_3_5.dat');
     case 36
        AA = load('network_1000_20_mu0_3_6.dat');
        u = load('community_1000_20_mu0_3_6.dat');
     case 37
        AA = load('network_1000_20_mu0_3_7.dat');
        u = load('community_1000_20_mu0_3_7.dat');
     case 38
        AA = load('network_1000_20_mu0_3_8.dat');
        u = load('community_1000_20_mu0_3_8.dat');
     case 39
        AA = load('network_1000_20_mu0_3_9.dat');
        u = load('community_1000_20_mu0_3_9.dat');
     case 40
        AA = load('network_1000_20_mu0_3_10.dat');
        u = load('community_1000_20_mu0_3_10.dat');
    case 41
        AA = load('network_1000_20_mu0_4_1.dat');
        u = load('community_1000_20_mu0_4_1.dat');
    case 42
        AA = load('network_1000_20_mu0_4_2.dat');
        u = load('community_1000_20_mu0_4_2.dat');
    case 43
        AA = load('network_1000_20_mu0_4_3.dat');
        u = load('community_1000_20_mu0_4_3.dat');
     case 44
        AA = load('network_1000_20_mu0_4_4.dat');
        u = load('community_1000_20_mu0_4_4.dat');
     case 45
        AA = load('network_1000_20_mu0_4_5.dat');
        u = load('community_1000_20_mu0_4_5.dat');
     case 46
        AA = load('network_1000_20_mu0_4_6.dat');
        u = load('community_1000_20_mu0_4_6.dat');
     case 47
        AA = load('network_1000_20_mu0_4_7.dat');
        u = load('community_1000_20_mu0_4_7.dat');
     case 48
        AA = load('network_1000_20_mu0_4_8.dat');
        u = load('community_1000_20_mu0_4_8.dat');
     case 49
        AA = load('network_1000_20_mu0_4_9.dat');
        u = load('community_1000_20_mu0_4_9.dat');
     case 50
        AA = load('network_1000_20_mu0_4_10.dat');
        u = load('community_1000_20_mu0_4_10.dat');
    case 51
        AA = load('network_1000_20_mu0_5_1.dat');
        u = load('community_1000_20_mu0_5_1.dat');
    case 52
        AA = load('network_1000_20_mu0_5_2.dat');
        u = load('community_1000_20_mu0_5_2.dat');
    case 53
        AA = load('network_1000_20_mu0_5_3.dat');
        u = load('community_1000_20_mu0_5_3.dat');
     case 54
        AA = load('network_1000_20_mu0_5_4.dat');
        u = load('community_1000_20_mu0_5_4.dat');
     case 55
        AA = load('network_1000_20_mu0_5_5.dat');
        u = load('community_1000_20_mu0_5_5.dat');
     case 56
        AA = load('network_1000_20_mu0_5_6.dat');
        u = load('community_1000_20_mu0_5_6.dat');
     case 57
        AA = load('network_1000_20_mu0_5_7.dat');
        u = load('community_1000_20_mu0_5_7.dat');
     case 58
        AA = load('network_1000_20_mu0_5_8.dat');
        u = load('community_1000_20_mu0_5_8.dat');
     case 59
        AA = load('network_1000_20_mu0_5_9.dat');
        u = load('community_1000_20_mu0_5_9.dat');
     case 60
        AA = load('network_1000_20_mu0_5_10.dat');
        u = load('community_1000_20_mu0_5_10.dat');
    case 61
        AA = load('network_1000_20_mu0_6_1.dat');
        u = load('community_1000_20_mu0_6_1.dat');
    case 62
        AA = load('network_1000_20_mu0_6_2.dat');
        u = load('community_1000_20_mu0_6_2.dat');
    case 63
        AA = load('network_1000_20_mu0_6_3.dat');
        u = load('community_1000_20_mu0_6_3.dat');
     case 64
        AA = load('network_1000_20_mu0_6_4.dat');
        u = load('community_1000_20_mu0_6_4.dat');
     case 65
        AA = load('network_1000_20_mu0_6_5.dat');
        u = load('community_1000_20_mu0_6_5.dat');
     case 66
        AA = load('network_1000_20_mu0_6_6.dat');
        u = load('community_1000_20_mu0_6_6.dat');
     case 67
        AA = load('network_1000_20_mu0_6_7.dat');
        u = load('community_1000_20_mu0_6_7.dat');
     case 68
        AA = load('network_1000_20_mu0_6_8.dat');
        u = load('community_1000_20_mu0_6_8.dat');
     case 69
        AA = load('network_1000_20_mu0_6_9.dat');
        u = load('community_1000_20_mu0_6_9.dat');
     case 70
        AA = load('network_1000_20_mu0_6_10.dat');
        u = load('community_1000_20_mu0_6_10.dat');
     case 71
        AA = load('network_1000_20_mu0_7_1.dat');
        u = load('community_1000_20_mu0_7_1.dat');
    case 72
        AA = load('network_1000_20_mu0_7_2.dat');
        u = load('community_1000_20_mu0_7_2.dat');
    case 73
        AA = load('network_1000_20_mu0_7_3.dat');
        u = load('community_1000_20_mu0_7_3.dat');
     case 74
        AA = load('network_1000_20_mu0_7_4.dat');
        u = load('community_1000_20_mu0_7_4.dat');
     case 75
        AA = load('network_1000_20_mu0_7_5.dat');
        u = load('community_1000_20_mu0_7_5.dat');
     case 76
        AA = load('network_1000_20_mu0_7_6.dat');
        u = load('community_1000_20_mu0_7_6.dat');
     case 77
        AA = load('network_1000_20_mu0_7_7.dat');
        u = load('community_1000_20_mu0_7_7.dat');
     case 78
        AA = load('network_1000_20_mu0_7_8.dat');
        u = load('community_1000_20_mu0_7_8.dat');
     case 79
        AA = load('network_1000_20_mu0_7_9.dat');
        u = load('community_1000_20_mu0_7_9.dat');
     case 80
        AA = load('network_1000_20_mu0_7_10.dat');
        u = load('community_1000_20_mu0_7_10.dat');
    case 81
        AA = load('network_1000_20_mu0_8_1.dat');
        u = load('community_1000_20_mu0_8_1.dat');
    case 82
        AA = load('network_1000_20_mu0_8_2.dat');
        u = load('community_1000_20_mu0_8_2.dat');
    case 83
        AA = load('network_1000_20_mu0_8_3.dat');
        u = load('community_1000_20_mu0_8_3.dat');
     case 84
        AA = load('network_1000_20_mu0_8_4.dat');
        u = load('community_1000_20_mu0_8_4.dat');
     case 85
        AA = load('network_1000_20_mu0_8_5.dat');
        u = load('community_1000_20_mu0_8_5.dat');
     case 86
        AA = load('network_1000_20_mu0_8_6.dat');
        u = load('community_1000_20_mu0_8_6.dat');
     case 87
        AA = load('network_1000_20_mu0_8_7.dat');
        u = load('community_1000_20_mu0_8_7.dat');
     case 88
        AA = load('network_1000_20_mu0_8_8.dat');
        u = load('community_1000_20_mu0_8_8.dat');
     case 89
        AA = load('network_1000_20_mu0_8_9.dat');
        u = load('community_1000_20_mu0_8_9.dat');
     case 90
        AA = load('network_1000_20_mu0_8_10.dat');
        u = load('community_1000_20_mu0_8_10.dat');
 end


A = zeros(n, n);
for i = 1 : size(AA, 1)
    A(AA(i, 1), AA(i, 2)) = 1;
    if( A(AA(i, 2), AA(i, 1)) == 0)
        A(AA(i, 2), AA(i, 1)) = 1;
    end
end

A = sparse(A);
[n, ~]=size(A);
SallA = sum(sum(A));
fprintf('sparsity:%1.3f\n',sum(sum(abs(full(A)) < 1e-5)) / (n * n));

GT = u(:,2);

% testing Inexact AManPG methods over feasible set with other existing methods 
p_inexact=p;
[V, D] = eigs(@(v)Mv(v, A), n, p-1);

Zo = [V, ones(n, 1) / sqrt(n)];

% x0 = Zo;
x0_inexact = Zo;

% rho=0.5;    
% mu=0.1;
% [proj_xopt, fs, Ds, sparsity, iter, nf, ng, nR,totalinneriterx, totalinneritery,totaltotalCGiter,nrestart,err,comtime] = driver_AmanPG_SparseComputation(A, SallA, x0, n, p, 1e-3, 500, mu, 1e-10, -inf);
% fprintf('time of AManPG with fixed tol:%f\n', comtime);
% 
% transform proj_xopt to assignment matrix by making the abs maximum value of each row as 1, others as 0
% proj_xopt_assign=abs(proj_xopt);
% for row=1:n
%     [~, index]=max(proj_xopt_assign(row,:));        
%     if(proj_xopt_assign(row, index)~=0)
%         proj_xopt_assign(row, index)=1;
%     end
%     for column=1:p
%         if(column~=index)
%            proj_xopt_assign(row, column)=0;
%         end
%     end
% end
% 
% modu_assign = modu(proj_xopt_assign, A)
% 
% ind=zeros(1,n);
% for i=1:n
%     ind(i)=find(proj_xopt_assign(i,:));
% end
% ind;
% 
% format long      
% NMI=nmi(GT, ind)
% AMI=ami(GT+1, ind)
% Purity=purity(GT, ind)

% rho_inexact=0.5;
mu_inexact=0.3;
[proj_xopt_inexact, fs_inexact, Ds_inexact, sparsity_inexact, iter_inexact, nf_inexact, ng_inexact, nR_inexact,totalinneriterx_inexact, totalinneritery_inexact,totaltotalCGiter_inexact,nrestart_inexact,err_inexact,comtime_inexact] = driver_AManPG_Approx_SparseComputation(A, SallA, x0_inexact, n, p, 1e-3, 500, mu_inexact, -inf);
fprintf('time of AManPG with dynamically update tol:%f\n', comtime_inexact);

%transform proj_xopt_inexact to assignment matrix by making the abs maximum value of each row as 1, others as 0
proj_xopt_inexact_assign=abs(proj_xopt_inexact);
for row=1:n
    [~, index]=max(proj_xopt_inexact_assign(row,:));        
    if(proj_xopt_inexact_assign(row, index)~=0)
        proj_xopt_inexact_assign(row, index)=1;
    end
    for column=1:p
        if(column~=index)
           proj_xopt_inexact_assign(row, column)=0;
        end
    end
end

modu_assign_inexact = modu(proj_xopt_inexact_assign, A);

ind_inexact=zeros(1,n);
for i=1:n
    ind_inexact(i)=find(proj_xopt_inexact_assign(i,:));
end
%ind;

%format long      
NMI_inexact=nmi(GT, ind_inexact)
AMI_inexact=ami(GT+1, ind_inexact)
if max(GT)>=max(ind_inexact)
    Purity_inexact=purity(GT, ind_inexact)
else
    Purity_inexact=purity(ind_inexact,GT)
end

end

function output = Mv(v, A)
    n = size(A, 1);
    SallA = sum(sum(A));
    tmp = A * ones(n, 1);
    output = A * v - tmp * ((tmp' * v) / SallA);
end
    
function output=projection(x, eta)
    q_star = x' * eta / norm(x' * eta);
    output = eta * q_star' + x - x * (q_star * q_star');
end

function output = LinesearchInput(x, eta, t0, s0)
    output = 1;
end

function output = IsStopped(x, gf, f, ngf, ngf0)
    output = ngf / ngf0 < 1e-5;
end

function [output, x] = f(x, A, D) %Keep A to get B, make sure sparse computation
[n, ~]=size(A); 
temp=A*sparse(ones(n, 1)); 
SallA = sum(sum(A));
Z=sparse(x.main'*temp);
x.BUD = A * x.main * D-temp*(Z'* D)/SallA;
output = - x.main(:)' * x.BUD(:);
end

function [output, x] = modu(x, A)
    [n,~]=size(A);
    temp=A*ones(n, 1); 
    SallA = sum(sum(A));
    Z=sparse(x'*temp);
    xAx = A * x-temp*Z'/SallA;
    output = sum(x(:) .* xAx(:))/SallA;
end

function [output, x] = gf(x, A, D) %Keep A to get B, make sure sparse computation
output.main = - 2 * x.BUD;
end

function [output, x] = Hess(x, eta, A, D) %Keep A to get B, make sure sparse computation
[n, ~]=size(A); 
temp=A*sparse(ones(n, 1)); 
SallA = sum(sum(A));
Z=sparse(eta.main'*temp);
output.main = - 2 * A * eta.main * D + 2*temp*(Z'* D)/SallA;
end

function [output, x] = PreCon(x, eta)
output = eta;
end