clear

seed = floor(rand() * 1000000);       
fprintf('random seed:%d\n', seed);
rng(seed); 
rng(1);

%% read image, change color image to brightness image, resize to 160x160
% I = imread_ncut('Ncut_9/jpg_images/2.jpg',160,160);
% 1.jpg, 2.jpg, 3.jpg 'peppers.png' 'onion.png', 'football.jpg', coins.png, cameraman.tif, 
                                        %'gantrycrane.png' 'liftingbody.png', 'tape.png', 'pears.png', 'saturn.png'

imagenames = {'baby.jpg', 'cameraman.tif', 'coins.png', 'football.jpg', ...
    'gantrycrane.png', 'hands1.jpg', 'kids.tif', 'liftingbody.png', 'lighthouse.png', 'llama.jpg', 'onion.png', 'panther.jpg', ...
    'pears.png', 'parkavenue.jpg', 'peppers.png', 'saturn.png', 'tape.png', 'yellowlily.jpg'};
% imagenames = {'football.jpg'};%, 'llama.jpg', 'parkavenue.jpg', 'yellowlily.jpg'};
ps = [3, 5, 7];
numtests = 10;

tab = 0;% zeros([length(ps), 8, length(imagenames), numtests]);

for i = 1 : length(imagenames)
%     Im = imread(imagenames{i});
%     I = imread_ncut(imagenames{i}, size(Im, 1), size(Im, 2));
    I = imread_ncut(imagenames{i}, 160, 160);
    for j = 1 : length(ps)
        p = ps(j);
        nbcluster = p;
        [W,imageEdges] = ICgraph(I);
        n = size(W, 1);
        [NcutEigenvectors,NcutEigenvalues, A, Dinvsqrt, vbar, W] = ncut(W,nbcluster);
        Dsqrt = spdiags(Dinvsqrt.^(-1), 0, n, n);
        Dinv = spdiags(Dinvsqrt.^2, 0, n, n);
        D = Dinvsqrt.^(-2);
        for k = 1 : numtests
            rng(k);
            
            %% SM method
            [NcutDiscrete,~] =discretisation(NcutEigenvectors);
            NcutDiscrete = full(NcutDiscrete);
            tab(j, 1, i, k) = fct(NcutDiscrete, Dsqrt, Dinvsqrt, W);
            
            Ncutidx = matrixtoidx(NcutDiscrete);
            Ncutidx = wknKmeans( Dinv * W * Dinv, D, Ncutidx);
            NcutM = idxtomatrix(Ncutidx, n, p);

            tab(j, 2, i, k) = fct(NcutM, Dsqrt, Dinvsqrt, W);
            
            %% Bach and Jordan
            kmidx = kmeans(vbar, p);
            BJwnkidx = BJwknKmeans(vbar, D, kmidx);
            BJwnkM = idxtomatrix(BJwnkidx, n, p);
            tab(j, 3, i, k) = fct(BJwnkM, Dsqrt, Dinvsqrt, W);
            
            BJwnkidx = matrixtoidx(BJwnkM);
            BJwnkidx = wknKmeans( Dinv * W * Dinv, D, BJwnkidx);
            BJwnkM = idxtomatrix(BJwnkidx, n, p);
            tab(j, 4, i, k) = fct(BJwnkM, Dsqrt, Dinvsqrt, W);
            
            %%METIS initialization
            METISidx = metispart(sparse(A), p) + 1;
            METISM = idxtomatrix(METISidx, n, p);
            tab(j, 5, i, k) = fct(METISM, Dsqrt, Dinvsqrt, W);
            
            METISidx = matrixtoidx(METISM);
            METISidx = wknKmeans( Dinv * W * Dinv, D, METISidx);
            METISM = idxtomatrix(METISidx, n, p);
            tab(j, 6, i, k) = fct(METISM, Dsqrt, Dinvsqrt, W);

            %% AManGP initialization
            v = Dinvsqrt.^(-1);
            v = v / norm(v,'fro');
            Zo = projection(vbar, v);
            x0_inexact = Zo;
            eigsA = eigs(A, 1);
            for mu_inexact = [0.01, 0.05, 0.2] / norm(x0_inexact, 1) * eigsA; %[0.001, 0.01， 0.1, 1] [0.01, 0.03, 0.1]
                [x0_inexact, fs, Ds, sparsity,comtime_inexact] = driver_AManPG_Approx_SparseComputation(A, x0_inexact, v, n, p, 1e-2, 5000, mu_inexact, -inf);
                [p, k, mu_inexact, sparsity]
            end
            AMannPGsoln = spdiags(Dinvsqrt,0,n,n) * x0_inexact;
            
%             for  hh=1:size(AMannPGsoln,2)
%                 AMannPGsoln(:,hh) = (AMannPGsoln(:,hh) / norm(AMannPGsoln(:,hh))  )*norm(ones(n,1));
%                 if AMannPGsoln(1,hh)~=0
%                     AMannPGsoln(:,hh) = - AMannPGsoln(:,hh) * sign(AMannPGsoln(1,hh));
%                 end
%             end
%             [EAManPGM,AMannPGsoln] =discretisation(AMannPGsoln);
%             EAManPGidx = matrixtoidx(EAManPGM);
            
            EAManPGidx = matrixtoidx(AMannPGsoln);
            EAManPGM = idxtomatrix(EAManPGidx, n, p);
            tab(j, 7, i, k) = fct(EAManPGM, Dsqrt, Dinvsqrt, W);
            
            EAManPGidx = wknKmeans( Dinv * W * Dinv, D, EAManPGidx);
            EAManPGM = idxtomatrix(EAManPGidx, n, p);
            tab(j, 8, i, k) = fct(EAManPGM, Dsqrt, Dinvsqrt, W);

%             [nr,nc,nb] = size(I);
%             SegLabel = zeros(nr,nc);
%             for j=1:size(EAManPGM,2),
%                 SegLabel = SegLabel + j*reshape(EAManPGM(:,j),nr,nc);
%             end
%             figure(2);clf
%             bw = edge(SegLabel,0.01);
%             J1=showmask(I,imdilate(bw,ones(2,2))); imagesc(J1);axis off
%             return;
        end
    end
end

avetab = mean(tab, 4);
c = categorical({'SM','SM-k','BJ','BJ-k','ME','ME-k','AM','AM-k',});

for j = 1 : size(tab, 3)
    h = figure(j);clf;
    set(0,'defaultaxesfontsize',15, ...
       'defaultaxeslinewidth',0.7, ...
       'defaultlinelinewidth',.8,'defaultpatchlinewidth',0.8);
    set(0,'defaultlinemarkersize',10)
    for i = 1 : length(ps)
        subplot(1, length(ps), i);
        bar(c, avetab(i, :, j)');
        title([num2str(ps(i)) ' clusters']);
        ymin = min(avetab(i, :, j));
        ymax = max(avetab(i, :, j));
        ylim( [ ymin - 0.1 * (ymax - ymin), ymax + 0.1 * (ymax - ymin) ] );
        if(i == 1)
            ylabel('- f_{NC}')
        end
    end
    tmp = split(imagenames{j}, '.');
    suptitle([tmp{1}, ' image']);
    set(h,'position',[100 100 630 480]);
    savefig([tmp{1}, '.fig']);
end
% return;


function Midx = matrixtoidx(M)
    n = size(M, 1);
    Midx = zeros(n, 1);
    for i = 1 : n
        [~, Midx(i)] = max(abs(M(i, :)));
    end
end

function output = idxtomatrix(idx, n, p)
    output = sparse(n, p);
    for i = 1 : n
        output(i, idx(i)) = 1;
    end
%     for i = 1 : p
%         output(:, i) = output(:, i) / norm(output(:, i));
%     end
end
function output = fct(X, Dsqrt, Dinvsqrt, W)
    n = size(X, 1);
    Y = orth(full(Dsqrt * X));
    tmp = spdiags(Dinvsqrt, 0, n, n) * W * spdiags(Dinvsqrt, 0, n, n) * Y;
    output = sum(sum(tmp .* Y));
end

function output = Mv(v, A)
    n = size(A, 1);
    output = A * v;
end
    
function output=projection(x, eta)
    q_star = x' * eta / norm(x' * eta);
    output = eta * q_star' + x - x * (q_star * q_star');
end

function output = LinesearchInput(x, eta, t0, s0)
    output = 1;
end

function output = IsStopped(x, gf, f, ngf, ngf0)
    output = ngf / ngf0 < 1e-5;
end

function [output, x] = f(x, A, D) %Keep A to get B, make sure sparse computation
[n, ~]=size(A); 
temp=A*sparse(ones(n, 1)); 
SallA = sum(sum(A));
Z=sparse(x.main'*temp);
x.BUD = A * x.main * D-temp*(Z'* D)/SallA;
output = - x.main(:)' * x.BUD(:);
end

function [output, x] = gf(x, A, D) %Keep A to get B, make sure sparse computation
output.main = - 2 * x.BUD;
end

function [output, x] = Hess(x, eta, A, D) %Keep A to get B, make sure sparse computation
[n, ~]=size(A); 
temp=A*sparse(ones(n, 1)); 
SallA = sum(sum(A));
Z=sparse(eta.main'*temp);
output.main = - 2 * A * eta.main * D + 2*temp*(Z'* D)/SallA;
end

function [output, x] = PreCon(x, eta)
output = eta;
end
