clear

seed = floor(rand() * 1000000);       
fprintf('random seed:%d\n', seed);
rng(seed); 
rng(1);

%% read image, change color image to brightness image, resize to 160x160
% I = imread_ncut('Ncut_9/jpg_images/2.jpg',160,160);
% 1.jpg, 2.jpg, 3.jpg 'peppers.png' 'onion.png', 'football.jpg', coins.png, cameraman.tif, 
                                        %'gantrycrane.png' 'liftingbody.png', 'tape.png', 'pears.png', 'saturn.png'
I = imread_ncut('baby.jpg',160,160);
% I = imread_ncut('coins.png',160,160);

imagesc(I);
return;

nbcluster = 7;
p = 7;

[W,imageEdges] = ICgraph(I);
n = size(W, 1);
% fprintf('sparsity:%1.3f\n',sum(sum(abs(full(A)) < 1e-5)) / (n * n));
[NcutEigenvectors,NcutEigenvalues, A, Dinvsqrt, vbar, W] = ncut(W,nbcluster);
Dsqrt = spdiags(Dinvsqrt.^(-1), 0, n, n);

%% YS method
[NcutDiscrete,~] =discretisation(NcutEigenvectors);
NcutDiscrete = full(NcutDiscrete);

Xt = orth(Dsqrt * NcutDiscrete);
tmp = spdiags(Dinvsqrt, 0, n, n) * W * spdiags(Dinvsqrt, 0, n, n) * Xt;
f11 = sum(sum(tmp .* Xt));

Dinv = spdiags(Dinvsqrt.^2, 0, n, n);
D = Dinvsqrt.^(-2);
Ncutidx = zeros(n, 1);
for i = 1 : n
    [~, Ncutidx(i)] = max(abs(NcutDiscrete(i, :)));
end
Ncutidx = wknKmeans( Dinv * W * Dinv, D, Ncutidx);
NcutM = idxtomatrix(Ncutidx, n, p);

Dsqrt = spdiags(Dinvsqrt.^(-1), 0, n, n);
Xt = orth(full(Dsqrt * NcutM));
tmp = spdiags(Dinvsqrt, 0, n, n) * W * spdiags(Dinvsqrt, 0, n, n) * Xt;
f12 = sum(sum(tmp .* Xt));

fYS = [f11, f12]

[nr,nc,nb] = size(I);
SegLabel = zeros(nr,nc);
for j=1:size(NcutM,2),
    SegLabel = SegLabel + j*reshape(NcutM(:,j),nr,nc);
end
figure(1);clf
bw = edge(SegLabel,0.01);
J1=showmask(I,imdilate(bw,ones(2,2))); imagesc(J1);axis off

% return;

%% AManGP initialization
n = size(W, 1);
% A = A / eigs(A, 1);
v = Dinvsqrt.^(-1);
v = v / norm(v,'fro');
% Zo = vbar;%projection(vbar, v);
Zo = projection(vbar, v);
x0_inexact = Zo;
for mu_inexact = [0.001, 0.01, 0.1, 1] / norm(x0_inexact, 1) % [0.0001]%,0.001, 0.01]%, 0.0001, 0.001]% [0.001, 0.01, 0.1]
    [x0_inexact, fs, Ds, sparsity,comtime_inexact] = driver_AManPG_Approx_SparseComputation(A, x0_inexact, v, n, p, 1e-2, 5000, mu_inexact, -inf);
end
fprintf('time of AManPG with dynamically update tol:%f\n', comtime_inexact);
AMannPGsoln = spdiags(Dinvsqrt,0,n,n) * x0_inexact;

% for  i=1:size(AMannPGsoln,2)
%     AMannPGsoln(:,i) = (AMannPGsoln(:,i) / norm(AMannPGsoln(:,i))  )*norm(ones(n,1));
%     if AMannPGsoln(1,i)~=0
%         AMannPGsoln(:,i) = - AMannPGsoln(:,i) * sign(AMannPGsoln(1,i));
%     end
% end

% [EAManPGM,AMannPGsoln] =discretisation(AMannPGsoln);
EAManPGM = zeros(size(AMannPGsoln));
for i = 1 : n
    [~, idx] = max(abs(AMannPGsoln(i, :)));
    EAManPGM(i, idx) = 1;
end

EAManPGM = full(EAManPGM);

Xt = orth(Dsqrt * EAManPGM);
tmp = spdiags(Dinvsqrt, 0, n, n) * W * spdiags(Dinvsqrt, 0, n, n) * Xt;
f21 = sum(sum(tmp .* Xt))

Dinv = spdiags(Dinvsqrt.^2, 0, n, n);
D = Dinvsqrt.^(-2);
EAManPGidx = zeros(n, 1);
for i = 1 : n
    [~, EAManPGidx(i)] = max(abs(EAManPGM(i, :)));
end
EAManPGidx = wknKmeans( Dinv * W * Dinv, D, EAManPGidx); %+ 0.01 * spdiags(Dinv, 0, n, n)
EAManPGM = idxtomatrix(EAManPGidx, n, p);

Dsqrt = spdiags(Dinvsqrt.^(-1), 0, n, n);
Xt = orth(full(Dsqrt * EAManPGM));
tmp = spdiags(Dinvsqrt, 0, n, n) * W * spdiags(Dinvsqrt, 0, n, n) * Xt;
f22 = sum(sum(tmp .* Xt));

AManPGf = [f21, f22]

[nr,nc,nb] = size(I);
SegLabel = zeros(nr,nc);
for j=1:size(EAManPGM,2),
    SegLabel = SegLabel + j*reshape(EAManPGM(:,j),nr,nc);
end
figure(2);clf
bw = edge(SegLabel,0.01);
J1=showmask(I,imdilate(bw,ones(2,2))); imagesc(J1);axis off
% return

%% Bach and Jordan intialization
D = Dinvsqrt.^(-2);
kmidx = kmeans(vbar, p);
BJwnkidx = BJwknKmeans(vbar, D, kmidx);
BJwnkM = idxtomatrix(BJwnkidx, n, p);

Xt = orth(full(Dsqrt * BJwnkM));
tmp = spdiags(Dinvsqrt, 0, n, n) * W * spdiags(Dinvsqrt, 0, n, n) * Xt;
f31 = sum(sum(tmp .* Xt));

Dinv = spdiags(Dinvsqrt.^2, 0, n, n);
D = Dinvsqrt.^(-2);
BJwnkidx = zeros(n, 1);
for i = 1 : n
    [~, BJwnkidx(i)] = max(abs(BJwnkM(i, :)));
end
BJwnkidx = wknKmeans( Dinv * W * Dinv, D, BJwnkidx);
BJwnkM = idxtomatrix(BJwnkidx, n, p);

Dsqrt = spdiags(Dinvsqrt.^(-1), 0, n, n);
Xt = orth(full(Dsqrt * BJwnkM));
tmp = spdiags(Dinvsqrt, 0, n, n) * W * spdiags(Dinvsqrt, 0, n, n) * Xt;
f32 = sum(sum(tmp .* Xt));

BJwnkf = [f31, f32]


[nr,nc,nb] = size(I);
SegLabel = zeros(nr,nc);
for j=1:size(BJwnkM,2),
    SegLabel = SegLabel + j*reshape(BJwnkM(:,j),nr,nc);
end
figure(3);clf
bw = edge(SegLabel,0.01);
J1=showmask(I,imdilate(bw,ones(2,2))); imagesc(J1);axis off
% return;

%%METIS initialization
METISidx = metispart(sparse(A), p) + 1;
METISM = idxtomatrix(METISidx, n, p);

Xt = orth(full(Dsqrt * METISM));
tmp = spdiags(Dinvsqrt, 0, n, n) * W * spdiags(Dinvsqrt, 0, n, n) * Xt;
f41 = sum(sum(tmp .* Xt));

Dinv = spdiags(Dinvsqrt.^2, 0, n, n);
D = Dinvsqrt.^(-2);
METISidx = zeros(n, 1);
for i = 1 : n
    [~, METISidx(i)] = max(abs(METISM(i, :)));
end
METISidx = wknKmeans( Dinv * W * Dinv, D, METISidx);
METISM = idxtomatrix(METISidx, n, p);

Dsqrt = spdiags(Dinvsqrt.^(-1), 0, n, n);
Xt = orth(full(Dsqrt * METISM));
tmp = spdiags(Dinvsqrt, 0, n, n) * W * spdiags(Dinvsqrt, 0, n, n) * Xt;
f42 = sum(sum(tmp .* Xt));

METISf = [f41, f42]

[nr,nc,nb] = size(I);
SegLabel = zeros(nr,nc);
for j=1:size(METISM,2),
    SegLabel = SegLabel + j*reshape(METISM(:,j),nr,nc);
end
figure(4);clf
bw = edge(SegLabel,0.01);
J1=showmask(I,imdilate(bw,ones(2,2))); imagesc(J1);axis off
return;

function output = idxtomatrix(idx, n, p)
    output = sparse(n, p);
    for i = 1 : n
        output(i, idx(i)) = 1;
    end
%     for i = 1 : p
%         output(:, i) = output(:, i) / norm(output(:, i));
%     end
end

function output = Mv(v, A)
    n = size(A, 1);
    output = A * v;
end
    
function output=projection(x, eta)
    q_star = x' * eta / norm(x' * eta);
    output = eta * q_star' + x - x * (q_star * q_star');
end

function output = LinesearchInput(x, eta, t0, s0)
    output = 1;
end

function output = IsStopped(x, gf, f, ngf, ngf0)
    output = ngf / ngf0 < 1e-5;
end

function [output, x] = f(x, A, D) %Keep A to get B, make sure sparse computation
[n, ~]=size(A); 
temp=A*sparse(ones(n, 1)); 
SallA = sum(sum(A));
Z=sparse(x.main'*temp);
x.BUD = A * x.main * D-temp*(Z'* D)/SallA;
output = - x.main(:)' * x.BUD(:);
end

function [output, x] = gf(x, A, D) %Keep A to get B, make sure sparse computation
output.main = - 2 * x.BUD;
end

function [output, x] = Hess(x, eta, A, D) %Keep A to get B, make sure sparse computation
[n, ~]=size(A); 
temp=A*sparse(ones(n, 1)); 
SallA = sum(sum(A));
Z=sparse(eta.main'*temp);
output.main = - 2 * A * eta.main * D + 2*temp*(Z'* D)/SallA;
end

function [output, x] = PreCon(x, eta)
output = eta;
end
