seed = floor(rand() * 1000000);       
fprintf('random seed:%d\n', seed);
rng(seed); 
rng(1);


%% read image, change color image to brightness image, resize to 160x160
I = imread_ncut('Ncut_9/jpg_images/3.jpg',160,160);

[W,imageEdges] = ICgraph(I);
n = size(W, 1);
D = sum(W)';
spD = spdiags(D.^(-0.5), 0, n, n);
A = spD * W * spD;
v = D.^(0.5);
v = v / norm(v,'fro');
p = 5;

fprintf('sparsity:%1.3f\n',sum(sum(abs(full(A)) < 1e-5)) / (n * n));

% %% method in a library
% nbSegments = 5;
% disp('computing Ncut eigenvectors ...');
% tic;
% [SegLabel,NcutDiscrete,NcutEigenvectors,NcutEigenvalues,W,imageEdges]= NcutImage(I,nbSegments);
% disp(['The computation took ' num2str(toc) ' seconds on the ' num2str(size(I,1)) 'x' num2str(size(I,2)) ' image']);
% Ncutidx = zeros(n, 1);
% for i = 1 : n
%     [~, Ncutidx(i)] = max(abs(NcutDiscrete(i, :)));
% end
% % NcutM = idxtomatrix(Ncutidx, n, p);

%% AManGP initialization
[V, S] = eigs(@(v)Mv(v, A), n, p);
A = A / S(1);
% Zo = projection(V, v);
% x0_inexact = Zo;
% % mu_inexact = 0.5;
% % for mu_inexact = 0.1% [0.001, 0.01, 0.1]
% %     [x0_inexact, fs, Ds, sparsity,comtime_inexact] = driver_AManPG_Approx_SparseComputation(A, x0_inexact, v, n, p, 1e-3, 500, mu_inexact, -inf);
% % end
% % fprintf('time of AManPG with dynamically update tol:%f\n', comtime_inexact);
% 
% AMannPGsoln = spD * x0_inexact;
% EAManPGidx = zeros(n, 1);
% for i = 1 : n
%     [~, EAManPGidx(i)] = max(abs(AMannPGsoln(i, :)));
% end
% EAManPGM = full(idxtomatrix(EAManPGidx, n, p));
% invD = spdiags(D.^(-1), 0, n, n);
% wnkidx = wknKmeans(invD * W * invD, D, EAManPGidx);
% 
% [nmi(Ncutidx, wnkidx), ami(Ncutidx, wnkidx), purity(Ncutidx, wnkidx)]


% [nr,nc,nb] = size(I);
% SegLabel = zeros(nr,nc);
% for j=1:size(EAManPGM,2),
%     SegLabel = SegLabel + j*reshape(EAManPGM(:,j),nr,nc);
% end
% figure(3);clf
% bw = edge(SegLabel,0.01);
% J1=showmask(I,imdilate(bw,ones(2,2))); imagesc(J1);axis off
% return;

%% Yu and Shi initialization
Vstar = zeros(size(V));
for i = 1 : n
    Vstar(i, :) = V(i, :) / norm(V(i, :));
end
O = eye(p);
Opre = zeros(p, p);
while(true)
    tmp = Vstar * O;
    G = zeros(n, p);
    for i = 1 : n
        [~, idx] = max(tmp(i, :));
        G(i, idx(1)) = 1;
    end
    [U1, S1, V1] = svd(G' * Vstar);
    O = V1 * U1';
    if(norm(O - Opre) < 1e-3)
        break;
    end
    Opre = O;
end
YSidx = zeros(n, 1);
for i = 1 : n
    [~, YSidx(i)] = max(abs(G(i, :)));
end
YSidxM = full(idxtomatrix(YSidx, n, p));
wnkidxYS = wknKmeans(invD * W * invD, D, YSidx);
wnkidxYSM = full(idxtomatrix(wnkidxYS, n, p));
[nmi(Ncutidx, wnkidxYS), ami(Ncutidx, wnkidxYS), purity(Ncutidx, wnkidxYS)]

[nr,nc,nb] = size(I);
SegLabel = zeros(nr,nc);
for j=1:size(wnkidxYSM,2),
    SegLabel = SegLabel + j*reshape(wnkidxYSM(:,j),nr,nc);
end
figure(3);clf
bw = edge(SegLabel,0.01);
J1=showmask(I,imdilate(bw,ones(2,2))); imagesc(J1);axis off
return;

%% Bach and Jordan intialization




function output = idxtomatrix(idx, n, p)
    output = sparse(n, p);
    for i = 1 : n
        output(i, idx(i)) = 1;
    end
%     for i = 1 : p
%         output(:, i) = output(:, i) / norm(output(:, i));
%     end
end

function output = Mv(v, A)
    n = size(A, 1);
    output = A * v;
end
    
function output=projection(x, eta)
    q_star = x' * eta / norm(x' * eta);
    output = eta * q_star' + x - x * (q_star * q_star');
end

function output = LinesearchInput(x, eta, t0, s0)
    output = 1;
end

function output = IsStopped(x, gf, f, ngf, ngf0)
    output = ngf / ngf0 < 1e-5;
end

function [output, x] = f(x, A, D) %Keep A to get B, make sure sparse computation
[n, ~]=size(A); 
temp=A*sparse(ones(n, 1)); 
SallA = sum(sum(A));
Z=sparse(x.main'*temp);
x.BUD = A * x.main * D-temp*(Z'* D)/SallA;
output = - x.main(:)' * x.BUD(:);
end

function [output, x] = gf(x, A, D) %Keep A to get B, make sure sparse computation
output.main = - 2 * x.BUD;
end

function [output, x] = Hess(x, eta, A, D) %Keep A to get B, make sure sparse computation
[n, ~]=size(A); 
temp=A*sparse(ones(n, 1)); 
SallA = sum(sum(A));
Z=sparse(eta.main'*temp);
output.main = - 2 * A * eta.main * D + 2*temp*(Z'* D)/SallA;
end

function [output, x] = PreCon(x, eta)
output = eta;
end
